#ifndef QCOLORFILTERMODEL_H
#define QCOLORFILTERMODEL_H

#include <QSortFilterProxyModel>

//Проски модель для фильтрации по цвету
class QColorFilterModel : public QSortFilterProxyModel
{
  Q_OBJECT
public:
  //Возможные типы фильтрации
  enum FilterKind {
      Lightness,
      Saturation,
      Hue
  };

  explicit QColorFilterModel(QObject *parent = 0);
  void setFilterKind(FilterKind kind);
private:
  //текущий тип фильтрации (по умолчанию "Фильтрация по светлоте")
  FilterKind filterKind = Lightness;
  //пороговое значение фильтра
  int threshold = 0;
signals:

public slots:
  //слот реализующий обновление фильтрации
  void updateFilter(int threshold);
protected:
  //переопределенный метод фильтрации строки
  virtual bool filterAcceptsRow(int source_row, const QModelIndex &source_parent) const;
};

#endif // QCOLORFILTERMODEL_H
