#include "qcolorlistmodel.h"

QColorListModel::QColorListModel(QObject *parent) :
  QAbstractListModel(parent)
{
}

void QColorListModel::addItem(QColor value)
{
  items.append(value);
}


int QColorListModel::rowCount(const QModelIndex &parent) const
{
  return items.count();
}

QVariant QColorListModel::data(const QModelIndex &index, int role) const
{
  if (!index.isValid()){
    return QVariant();
  }
  //получение цвета по индексу элемента
  QColor color = items.at(index.row());

  switch (role) {
  case Qt::DisplayRole: //Отображение параметров цвета в текстовом виде
    return QString("Lightness: %1, Saturation: %2, Hue: %3")
        .arg(QString::number(color.lightness()))
        .arg(QString::number(color.saturation()))
        .arg(QString::number(color.hue()));
  case Qt::BackgroundColorRole: //Установка цвета фона элемента
    return color;
  case Qt::SizeHintRole: //Установка высоты элементов
    return QSize(0, 30);
  default:
    return QVariant();
  }
}
